;;
;; SAL 
;; Copyright (C) 2006, SRI International.  All Rights Reserved.
;;
;; This program is free software; you can redistribute it and/or 
;; modify it under the terms of the GNU General Public License 
;; as published by the Free Software Foundation; either version 2
;; of the License, or (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of 
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
;; GNU General Public License for more details. 
;;
;; You should have received a copy of the GNU General Public License
;; along with this program; if not, write to the Free Software 
;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 
;;

(module sal-esmc-idfs-support
        (include "sal.sch")
        (import sal-esm-options)
        (export (sal-esmc/idfs-wrapper dfs-proc))
        )

(define (next-bound curr-bound)
  (if *esm-max-depth*
    (min *esm-max-depth* (+ curr-bound *esmc-idfs-increment*))
    (+ curr-bound *esmc-idfs-increment*)))

(define (sal-esmc/idfs-wrapper dfs-proc)
  (let loop ((bound (next-bound 0)))
    (let ((result (dfs-proc bound)))
      (cond
       ((eq? result 'unknown)
        (if (and *esm-max-depth* (= bound *esm-max-depth*))
          result
          (let ((new-bound (next-bound bound)))
            (status-message :esm-idfs-increasing-bound new-bound)
            (verbose-message 2 "  increasing bound to: ~a" new-bound)
            (loop new-bound))))
       (else
        result)))))
